(provide 'hatena-vars)

(defgroup hatena nil
  "major mode for Hatena::Diary"
  :prefix "hatena-"
  :group 'hypermedia)

(defgroup hatena-face nil
  "Hatena, Faces."
  :prefix "hatena-"
  :group 'hatena)

(defcustom hatena-usrid nil
  "hatena-diary-mode Υ桼̾"
  :type 'string
  :group 'hatena)

(defcustom hatena-directory 
  (expand-file-name "~/.hatena/")
  "¸ǥ쥯ȥ."
  :type 'directory
  :group 'hatena)

(defcustom hatena-init-file (concat
			     (file-name-as-directory hatena-directory)
			     "init")
  "*hatena-diary-mode νե롣"
  :type 'file
  :group 'hatena)

(defcustom hatena-password-file 
  (expand-file-name (concat hatena-directory ".password"))
  "ѥ¸ե"
  :type 'file
  :group 'hatena)

(defcustom hatena-entry-type 1
  "ȥΥޡå * ɤΤ褦˽뤫
0ʤ *  *pn* ˡ1 ʤ *  *<time>* ֤"
  :type 'integer
  :group 'hatena)

(defcustom hatena-change-day-offset 6
  "ϤƤʤ, դѤ .+6 Ǹ 6 դѹ."
  :type 'integer
  :group 'hatena)

(defcustom hatena-trivial nil
  "äȤ򤹤뤫ɤ. non-nil \"äȤ\"ˤʤ"
  :type 'boolean
  :group 'hatena)

(defcustom hatena-use-file t
  "ѥɤ(Ź沽)¸뤫ɤ non-nil ʤѥɤ base 64 ǥ󥳡ɤ¸"
  :type 'boolean
  :group 'hatena)

(defcustom hatena-cookie 
  (expand-file-name 
   (concat hatena-directory "Cookie@hatena"))
  "å̾"
  :type 'file
  :group 'hatena)

(defcustom hatena-browser-function nil  ;; ̤ϡ'browse-url
  "Function to call browser.
If non-nil, `hatena-submit' calls this function.  The function
is expected to accept only one argument(URL)."
  :type 'symbol
  :group 'hatena)

(defcustom hatena-proxy ""
  "curl ɬפʻꤹ"
  :type 'string
  :group 'hatena)

(defcustom hatena-default-coding-system 'euc-jp
  "ǥեȤΥǥ󥰥ƥ"
  :type 'symbol
  :group 'hatena)


(defcustom hatena-url "http://d.hatena.ne.jp/"
  "ϤƤʤΥɥ쥹"
  :type 'string
  :group 'hatena)

(defcustom hatena-twitter-flag nil
  "twitterΤ򤹤뤫ɤ. non-nil \"twitter\"ˤʤ"
  :type 'boolean
  :group 'hatena)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;եɽ
(defvar hatena-fname-regexp
  "\\([0-9][0-9][0-9][0-9]\\)\\([01][0-9]\\)\\([0-3][0-9]\\)$" )
(defvar hatena-diary-mode-map nil)

;;Ť
(defvar hatena-header-regexp 
  (concat "\\`      Title: \\(.*\\)\n"
          "Last Update: \\(.*\\)\n"
          "____________________________________________________" ))

(defvar hatena-tmpfile 
  (expand-file-name (concat hatena-directory "hatena-temp.dat")))
(defvar hatena-tmpfile2
  (expand-file-name (concat hatena-directory "hatena-temp2.dat")))
(defvar hatena-curl-command "curl" "curl ޥ")

(defvar hatena-twitter-prefix nil "twitterƤ")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;face

(defvar hatena-font-lock-keywords nil)
(defvar hatena-html-face 'hatena-html-face)
(defvar hatena-title-face 'hatena-title-face)
(defvar hatena-header-face 'hatena-header-face)
(defvar hatena-subtitle-face 'hatena-subtitle-face)
(defvar hatena-markup-face 'hatena-markup-face)
(defvar hatena-link-face 'hatena-link-face)

(defface hatena-title-face
  '((((class color) (background light)) (:foreground "Navy" :bold t))
    (((class color) (background dark)) (:foreground "wheat" :bold t)))
  "title face"
  :group 'hatena-face)

(defface hatena-header-face
  '((((class color) (background light)) (:foreground "Gray70" :bold t))
    (((class color) (background dark)) (:foreground "SkyBlue4" :bold t)))
  "last update face"
  :group 'hatena-face)

(defface hatena-subtitle-face 
  '((((class color) (background light)) (:foreground "DarkOliveGreen"))
    (((class color) (background dark)) (:foreground "wheat")))
  "֥ȥface"
  :group 'hatena-face)

(defface hatena-markup-face 
  '((((class color) (background light)) (:foreground "firebrick" :bold t))
    (((class color) (background dark)) (:foreground "IndianRed3" :bold t)))
  "ϤƤʤΥޡåפface"
  :group 'hatena-face)

(defface hatena-html-face 
  '((((class color) (background light)) (:foreground "DarkSeaGreen4"))
    (((class color) (background dark)) (:foreground "Gray50")))
  "htmlface"
  :group 'hatena-face)

(defface hatena-link-face 
  '((((class color) (background light)) (:foreground "DarkSeaGreen4"))
    (((class color) (background dark)) (:foreground "wheat")))
  "htmlǶޤ줿ʬface"
  :group 'hatena-face)

;-----------------------------------------------------------------------------------
; ϤƤʵˡإ
;-----------------------------------------------------------------------------------
(defvar hatena-help-syntax-index
  'dummy
  "ϻٱ絭ˡ `hatena-help-syntax-input'
   ư `hatena-help-syntax-autolink'
   ϤƤ⼫ư `hatena-help-syntax-hatena-autolink'
   ϻٱ絡ǽ `hatena-help-syntax-other'")

(defvar hatena-help-syntax-input
  'dummy
  "ϻٱ絭ˡ

|------------------------------+------------------------------+-----------------------------------------------------|
| ˡ̾                       |                          | ǽ                                                |
|------------------------------+------------------------------+-----------------------------------------------------|
| Фˡ                   | *                        | ˸Фh3ˤդޤ                        |
| դФˡ           | *t*, *t+1*           | ФԽ¸ɽޤ                  |
| name°դФˡ       | *name*                   | Ф˹ name °Ĥޤ                  |
| ƥ꡼ˡ               | *[]                  | ˥ƥ꡼ꤷޤ                        |
| Фˡ                 | **                       | ˾Фh4ˤĤޤ                      |
| Фˡ               | ***                      | ˾Фˡh5ˤĤޤ                |
| ꥹȵˡ                   | -, --, +, ++ | ꥹȡliˤñ˵Ҥޤ                      |
| ꥹȵˡ               | ::                   | ꥹȡdtˤñ˵Ҥޤ                  |
| ɽȤߵˡ                   | |   |   |            | ɽȤߡtableˤñ˵Ҥޤ                   |
|                              | |*  |   |            |                                                     |
| ѵˡ                     | >>  <<                   | ѥ֥åblockquoteˤñ˵Ҥޤ        |
| preˡ                      | >|  |<                   | ƥȤ򤽤Τޤɽޤpre         |
| ѡpreˡ              | >||  ||<                 | HTMLʤɤΥ򤽤Τޤɽޤpre |
| ѡpreˡ              | >|ե륿|  ||<   | ץΥɤ                  |
| ʥ󥿥åϥ饤ȡ | >|??|  ||<               | դɽޤpre                         |
|                              |                              |                                                     |
| aaˡ                       | >|aa|  ||<               | Ȥñˤ줤ɽޤ            |
| ˡ                     | ((  ))                   | ˵ꤷޤ                              |
| ³ɤ൭ˡ               | ====                         | θФޤǤθ³ɤפˤޤ  |
| ѡ³ɤ൭ˡ       | =====                        | ФޤƤθƤ³ɤפˤޤ  |
| Եˡ                     | (Ϣ³ι2)        | ԡbrˤޤ                              |
| pߵˡ                | ><  ><                   | ư p ߤޤ                   |
| texˡ                      | [tex:]                   | mimeTeX Ȥäƿɽޤ                    |
| 쵭ˡ                 | [uke:]                   | Υɽޤ                      |
|------------------------------+------------------------------+-----------------------------------------------------|
")
	
(defvar hatena-help-syntax-autolink
  'dummy
  "ư

|--------------------+---------------------------------+--------------------------------------------|
| ˡ̾             |                             | ǽ                                       |
|--------------------+---------------------------------+--------------------------------------------|
| httpˡ           | http://                     | URLؤλϤޤ󥯤ñ˵Ҥޤ      |
|                    | [http: //:title]            |                                            |
|                    | [http://:barcode]           |                                            |
|                    | [http://:image]             |                                            |
|                    |                                 |                                            |
| mailtoˡ         | mailto:                     | ᡼륢ɥ쥹ؤΥ󥯤ñ˵Ҥޤ |
| niconicoˡ       | [niconico:sm*******]            | ˥˥ưκץ졼䡼ɽޤ   |
| googleˡ         | [google:]                   | Google θ̤˥󥯤ޤ            |
|                    | [google:image:]             |                                            |
|                    | [google:news:]              |                                            |
|                    |                                 |                                            |
| mapˡ            | map:xy (:map)           | Googleޥåפɽ󥯤ޤ         |
|                    | [map:]                      |                                            |
|                    | [map:t:]                    |                                            |
|                    |                                 |                                            |
| amazonˡ         | [amazon:]                   | Amazon θ̤˥󥯤ޤ            |
| wikipediaˡ      | [wikipedia:]                | Wikipediaε˥󥯤ޤ              |
| twitterˡ        | twitter::title            | TwitterΤĤ֤䤭˥󥯤ޤ            |
|                    | twitter::tweet            |                                            |
|                    | twitter::detail           |                                            |
|                    | twitter::detail:right     |                                            |
|                    | twitter::detail:left      |                                            |
|                    | twitter::tree             |                                            |
|                    | [twitter:@hatenadiary]        |                                            |
|                    | [http://twitter.com/hatenadiary |                                            |
|                    | /status/:twitter:title]     |                                            |
| ưߵˡ | [] ϤƤʵˡ []                | ϤƤʵˡˤ뼫ư󥯤ߤޤ     |
|--------------------+---------------------------------+--------------------------------------------|
")

(defvar hatena-help-syntax-hatena-autolink
  'dummy
  "ϤƤ⼫ư

|---------------+-------------------------------+-------------------------------------------------|
| ˡ̾        |                           | ǽ                                            |
|---------------+-------------------------------+-------------------------------------------------|
| idˡ        | id: id::archive     | ϤƤʥ桼˥󥯤                      |
|               | id::aboutid::image  | ưȥåХåޤ                  |
|               | id::detailid:+  |                                                 |
|               |                               |                                                 |
| questionˡ  | question::title           | ϸϤƤʤ˥󥯤                      |
|               | question::detail          | ưȥåХåޤ                  |
|               | question::image           |                                                 |
|               |                               |                                                 |
| searchˡ    | [search:]                 | ϤƤʸθ̤˥󥯤ޤ              |
|               | [search:keyword:]         |                                                 |
|               | [search:question:]        |                                                 |
|               | [search:asin:]            |                                                 |
|               | [search:web:]             |                                                 |
|               |                               |                                                 |
| antennaˡ   | a:id:                     | ϤƤʥƥʤ˥󥯤ޤ                    |
| bookmarkˡ  | b:id: (:)             | ϤƤʥ֥åޡ˥󥯤ޤ                |
|               | [b:id::t:]            |                                                 |
|               | [b:t:]                    |                                                 |
|               | [b:keyword:]              |                                                 |
|               |                               |                                                 |
| diaryˡ     | d:id:                     | ϤƤʥ꡼˥󥯤                    |
|               | d:id:+                | ưȥåХåޤ                  |
|               | [d:keyword:]              |                                                 |
|               |                               |                                                 |
| fotolifeˡ  | f:id:::image          | ϤƤʥեȥ饤դμ̿ɽ              |
|               | f:id:::movie          | ưȥåХåޤ                  |
|               | f:id:(:favorite)          |                                                 |
|               |                               |                                                 |
| groupˡ     | g:                        | ϤƤʥ롼פ˥󥯤                      |
|               | g::id:                | ưȥåХåޤ                  |
|               | [g::keyword:]¾     |                                                 |
|               |                               |                                                 |
| haikuˡ     | [h:keyword:]              | ϤƤʥϥ˥󥯤ޤ                      |
|               | [h:id:]                   |                                                 |
|               |                               |                                                 |
| ideaˡ      | idea: (:title)            | ϤƤʥǥ˥󥯤                      |
|               | i:id:                     | ưȥåХåޤ                  |
|               | [i:t:]                    |                                                 |
|               |                               |                                                 |
| rssˡ       | r:id:                     | ϤƤRSS˥󥯤ޤ                         |
| graphˡ     | graph:id:                 | ϤƤʥդɽ󥯤ޤ              |
|               | [graph:id:: (:image)] |                                                 |
|               | [graph:t:]                |                                                 |
|               |                               |                                                 |
| keywordˡ   | [[[[]]]]                      | ɤ˥󥯤ޤ                        |
|               | [keyword:]                |                                                 |
|               | [keyword::graph]¾      |                                                 |
|               |                               |                                                 |
| isbn/asinˡ | isbn:             | ҡڡǲʤɤξҲ󥯤ɽޤ    |
|               | asin:                     |                                                 |
|               | isbn::title               |                                                 |
|               | isbn::image               |                                                 |
|               | isbn::detail¾          |                                                 |
|               |                               |                                                 |
| rakutenˡ   | [rakuten:]                | ŷԾξʤξҲ󥯤ɽޤ          |
| jan/eanˡ   | jan: ean:¾       | JAN/EANɤȤäʾҲ󥯤ɽޤ |
| ugomemoˡ   | ugomemo:                  | Žդޤ                          |
|---------------+-------------------------------+-------------------------------------------------|
")

(defvar hatena-help-syntax-other
  'dummy
  "ϻٱ絡ǽ

|--------------------------------------+----------------------------------------------------------|
| إ                               |                                                      |
|--------------------------------------+----------------------------------------------------------|
| *פ-פ򤽤Τޤ޹Ƭɽ | ʹƬȾѤζĤ                             |
| 񤭵ˡ                           | <!--  -->                                            |
| ¸ǽ                     | <ins>  </ins>, <del>  </del>                     |
| citetitle°                      | <blockquote cite=\"\" title=\"\">  </blockquote> |
| ư󥯤򥿥ǻȤ             | <a href=\"ϤƤʵˡ\">  </a>                          |
|--------------------------------------+----------------------------------------------------------|
")






